require "float_approx/version"

module FloatApprox
  Float.class_eval do
    def approx(other, relative_epsilon=Float::EPSILON, epsilon=Float::EPSILON)
      difference = other - self
      return true if difference.abs <= epsilon
      relative_error = (difference / (self > other ? self : other)).abs
      return relative_error <= relative_epsilon
    end

    def absolute_approx(other, epsilon=Float::EPSILON)
      return (other - self).abs <= epsilon
    end
  end
end
